/*
 * Copyright (c) 2008
 * Embedded Brains GmbH
 * Obere Lagerstr. 30
 * D-82178 Puchheim
 * Germany
 * rtems@embedded-brains.de
 *
 * The license and distribution terms for this file may be found in the file
 * LICENSE in this distribution or at http://www.rtems.com/license/LICENSE.
 */

package org.rtems.cdt.build;

import org.eclipse.cdt.make.internal.core.scannerconfig2.GCCSpecsRunSIProvider;
import org.eclipse.core.resources.IProject;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.Path;
import org.rtems.cdt.Constants;
import org.rtems.cdt.Storage;

public class RunScannerInfoProvider extends GCCSpecsRunSIProvider {
	protected boolean initialize() {
		if (!super.initialize()) {
			return false;
		}

		IProject project = resource.getProject();
		
		/*
		 * FIXME: This is a hack to avoid to early discovery of internal
		 * compiler include paths and symbols.  The discovery is suppressed for
		 * empty projects which contain only the '.project' and '.cproject'
		 * files.
		 */
		try {
			if (project.members().length < 3) {
				return false;
			}
		} catch (CoreException e) {
			e.printStackTrace();
			return false;
		}
		
		/*
		 * FIXME: Added absolute path since it seams that the build
		 * environment is ignored.
		 */
		fCompileCommand = new Path(
			Storage.getProperty( project, Constants.BASE_PATH_KEY)
		);
		fCompileCommand = fCompileCommand.append( "bin");
		fCompileCommand = fCompileCommand.append(
			Storage.getProperty( project, Constants.TARGET_KEY)
				+ "-rtems"
				+ Storage.getProperty( project, Constants.VERSION_KEY)
				+ "-gcc"
		);
		
		return true;
	}
}
